searchData={"items":[{"type":"module","title":"AMQPHelpers.HighThroughput","doc":"Utilities for dealing with high-throughput scenarios.\n\nThis module provides a couple of functions which enforce some options to\nachieve good results on high throughput scenarios. Review the\n[High Throughput section](readme.html#high-throughput) for more information.","ref":"AMQPHelpers.HighThroughput.html"},{"type":"function","title":"AMQPHelpers.HighThroughput.consume/5","doc":"Registers a queue consumer process.\n\nLike `AMQP.Basic.consume/4` but enforces options which play nicely with a high\nthroughput scenario.","ref":"AMQPHelpers.HighThroughput.html#consume/5"},{"type":"function","title":"AMQPHelpers.HighThroughput.publish/6","doc":"Publishes a message to an Exchange.\n\nLike `AMQP.Basic.publish/5` but enforces options which play nicely with a high\nthroughput scenario.","ref":"AMQPHelpers.HighThroughput.html#publish/6"},{"type":"module","title":"AMQPHelpers.RPC","doc":"A remote procedure call implementation.\n\nThis module provide a helper function which implements the RPC pattern using\nthe [Direct Reply-to](https://www.rabbitmq.com/direct-reply-to.html). This\nallows a client to send a request and receive a response synchronously,\nwithout having to manage any response queue.","ref":"AMQPHelpers.RPC.html"},{"type":"function","title":"AMQPHelpers.RPC.call/6","doc":"Executes a remote procedure call.\n\nThis function sends the given messages and waits for a response using\n[Direct Reply-to](https://www.rabbitmq.com/direct-reply-to.html).\n\nThis function uses a `Task` internally to wait for responses. This means\nall the caveats and OTP compatibility `Task` issues apply here too. Check\n`call_nolink/7` for more information.","ref":"AMQPHelpers.RPC.html#call/6"},{"type":"function","title":"AMQPHelpers.RPC.call_nolink/7","doc":"Executes a remote procedure call without linking to the calling process.\n\nLike `call/6` but it does not link the waiting process to the calling process.\nCheck `Task.Supervisor` for more information.","ref":"AMQPHelpers.RPC.html#call_nolink/7"},{"type":"behaviour","title":"AMQPHelpers.Adapter","doc":"A [behaviour](https://elixir-lang.org/getting-started/typespecs-and-behaviours.html#behaviours)\nfor the `AMQP` client implementation.\n\nThis module declares a behaviour for the `AMQP` library, allowing us to use\ndifferent implementations of the underlaying *AMQP* interface. Check out the\n`AMQPHelpers.Adapters.Stub` and `AMQPHelpers.Adapters.AMQP` for actual\nimplementations of this behaviour.\n\nThis behaviour also enables us to mock this interface in tests using libraries\nlike [Mox](https://hexdocs.pm/mox/Mox.html). Check out the libraries tests for\nexamples about this usage.","ref":"AMQPHelpers.Adapter.html"},{"type":"callback","title":"AMQPHelpers.Adapter.ack/3","doc":"Acknowledges one or more messages.\n\nSee `AMQP.Basic.ack/3`.","ref":"AMQPHelpers.Adapter.html#c:ack/3"},{"type":"callback","title":"AMQPHelpers.Adapter.cancel_consume/3","doc":"Stops the given consumer from consuming.\n\nSee `AMQP.Basic.cancel/3`.","ref":"AMQPHelpers.Adapter.html#c:cancel_consume/3"},{"type":"callback","title":"AMQPHelpers.Adapter.close_channel/1","doc":"Closes an open Channel.\n\nSee `AMQP.Channel.close/1`.","ref":"AMQPHelpers.Adapter.html#c:close_channel/1"},{"type":"callback","title":"AMQPHelpers.Adapter.consume/4","doc":"Registers a queue consumer process.\n\nSee `AMQP.Basic.consume/4`.","ref":"AMQPHelpers.Adapter.html#c:consume/4"},{"type":"callback","title":"AMQPHelpers.Adapter.enable_select_confirm/1","doc":"Activates publishing confirmations on the channel.\n\nSee `AMQP.Confirm.select/1`.","ref":"AMQPHelpers.Adapter.html#c:enable_select_confirm/1"},{"type":"callback","title":"AMQPHelpers.Adapter.fetch_application_channel/1","doc":"Provides an easy way to access an `t:AMQP.Channel.t/0`.\n\nSee `AMQP.Application.get_channel/1`.","ref":"AMQPHelpers.Adapter.html#c:fetch_application_channel/1"},{"type":"callback","title":"AMQPHelpers.Adapter.fetch_application_connection/1","doc":"Provides an easy way to access an `t:AMQP.Connection.t/0`.\n\nSee `AMQP.Application.get_connection/1`.","ref":"AMQPHelpers.Adapter.html#c:fetch_application_connection/1"},{"type":"callback","title":"AMQPHelpers.Adapter.get_next_delivery_tag/1","doc":"Returns the next message sequence number.\n\nSee `AMQP.Confirm.next_publish_seqno/1`.","ref":"AMQPHelpers.Adapter.html#c:get_next_delivery_tag/1"},{"type":"callback","title":"AMQPHelpers.Adapter.nack/3","doc":"Negative acknowledges of one or more messages.\n\nSee `AMQP.Basic.nack/3`.","ref":"AMQPHelpers.Adapter.html#c:nack/3"},{"type":"callback","title":"AMQPHelpers.Adapter.open_channel/1","doc":"Opens a new channel in a previously opened connection.\n\nSee `AMQP.Channel.open/2`.","ref":"AMQPHelpers.Adapter.html#c:open_channel/1"},{"type":"callback","title":"AMQPHelpers.Adapter.publish/5","doc":"Publishes a message to an Exchange.\n\nSee `AMQP.Basic.publish/5`.","ref":"AMQPHelpers.Adapter.html#c:publish/5"},{"type":"callback","title":"AMQPHelpers.Adapter.register_confirm_handler/2","doc":"Register a handler for confirms on channel.\n\nSee `AMQP.Confirm.register_handler/2`.","ref":"AMQPHelpers.Adapter.html#c:register_confirm_handler/2"},{"type":"callback","title":"AMQPHelpers.Adapter.register_return_handler/2","doc":"Registers a handler to deal with returned messages.\n\nSee `AMQP.Basic.return/2`.","ref":"AMQPHelpers.Adapter.html#c:register_return_handler/2"},{"type":"callback","title":"AMQPHelpers.Adapter.set_channel_options/2","doc":"Sets the message prefetch count or prefetch size.\n\nSee `AMQP.Basic.qos/2`.","ref":"AMQPHelpers.Adapter.html#c:set_channel_options/2"},{"type":"module","title":"AMQPHelpers.Adapters.AMQP","doc":"A `AMQPHelpers.Adapter` which relies in `AMQP` lib.\n\nThis module uses `AMQP` to implement the `AMQPHelpers.Adapter`. This is\nprobably the adapter that you want to use for production or integration tests\nbecause it uses the actual `AMQP` interface.","ref":"AMQPHelpers.Adapters.AMQP.html"},{"type":"module","title":"AMQPHelpers.Adapters.Stub","doc":"A `AMQPHelpers.Adapter` which just logs.\n\nThis module implements a stub for `AMQPHelpers.Adapter` which mainly logs\ncalls. You probably want to use this for non-integration testing or a\ndevelopment environment without a AMQP broker.","ref":"AMQPHelpers.Adapters.Stub.html"},{"type":"module","title":"AMQPHelpers.Reliability.Consumer","doc":"A consumer for dealing with reliability scenarios.\n\nA `AMQPHelpers.Reliability.Consumer` is process which manages a reliable\nconsume operation over *AMQP*, where messages are acknowledge to the broker\nafter processing them. Pair this process with a\n`AMQPHelpers.Reliability.Producer` to provide reliable message exchange.","ref":"AMQPHelpers.Reliability.Consumer.html"},{"type":"module","title":"Example - AMQPHelpers.Reliability.Consumer","doc":"This `Consumer` delivers messages to a `t:message_handler/0` which processes\nthese messages. The `Consumer` enforces the usage of `AMQP.Application`, so\nafter defining our application connection, channels and our message handler\nwe can create an instance of this process using `start_link/1` to start\nconsuming messages:\n\n    alias AMQPHelpers.Reliability.Consumer\n\n    my_message_handler = fn payload, meta ->\n      IO.inspect({payload, meta}, label: \"Got a message!\")\n    end\n\n    {:ok, consumer} = Consumer.start_link(\n      channel_name: :my_channel_name,\n      message_handler: :my_channel_name,\n      queue_name: \"my_queue_name\"\n    )","ref":"AMQPHelpers.Reliability.Consumer.html#module-example"},{"type":"function","title":"AMQPHelpers.Reliability.Consumer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"AMQPHelpers.Reliability.Consumer.html#child_spec/1"},{"type":"function","title":"AMQPHelpers.Reliability.Consumer.consume/1","doc":"Starts consuming messages.\n\nThis function is used to start consuming messages when `consume_on_init`\noption is set to false. Not required by default but useful for testing\npurposes.","ref":"AMQPHelpers.Reliability.Consumer.html#consume/1"},{"type":"function","title":"AMQPHelpers.Reliability.Consumer.start_link/1","doc":"Starts a `Consumer` process linked to the current process.","ref":"AMQPHelpers.Reliability.Consumer.html#start_link/1"},{"type":"function","title":"Options - AMQPHelpers.Reliability.Consumer.start_link/1","doc":"The following option can be given to `Consumer` when starting it. Note that\n`message_handler` and `queue_name` **are required**.\n\n  * `adapter` - Sets the `AMQPHelpers.Adapter`. Defaults to\n    `AMQPHelpers.Adapters.AMQP`.\n  * `channel` - The channel to use to consume messages. **NOTE**: do **not**\n    use this for production environments because this *Consumer* does not\n    supervise the given channel. Instead, use `channel_name` which makes use \n    of `AMQP.Application`.\n  * `channel_name` - The name of the configured channel to use. See\n    `AMQP.Application` for more information. Defaults to `:default`.\n  * `consume_on_init` - If the consumer should start consuming messages on init\n    or not. Defaults to `true`.\n  * `consume_options` - The options given to `c:AMQPHelpers.Adapter.consume/4`.\n  * `message_handler` - The function that will deal with messages. Required.\n  * `prefetch_count` - The maximum number of unacknowledged messages in the\n     channel. See `AMQP.Basic.qos2` for more info.\n  * `prefetch_size` - The maximum number of unacknowledged bytes in the\n     channel. See `AMQP.Basic.qos2` for more info.\n  * `queue_name` - The name of the queue to consume. Required.\n  * `requeue` - Whether to requeue messages or not after a consume error.\n    Defaults to `true`.\n  * `retry_interval` - The number of millisecond to wait if an error happens\n    when trying to consume messages or when trying to open a channel.\n  * `shutdown_gracefully` - If enabled, the consumer will cancel the\n    subscription when terminating. Default to `false` but enforced if\n    `consumer_options` has `exclusive` set to `true`.\n  * `task_supervisor` - The `Task.Supervisor` which runs message handling\n    tasks. If not provided, the `Consumer` will handle messages\n    synchronously.\n\n`t:GenServer.options/0` are also available. See `GenServer.start_link/2` for\nmore information about these.","ref":"AMQPHelpers.Reliability.Consumer.html#start_link/1-options"},{"type":"type","title":"AMQPHelpers.Reliability.Consumer.message_handler/0","doc":"The function that handle messages.\n\nA message handler is a function that will deal with the consumed messaged. It\nwill receive the payload of the message as first argument, and the message\nmetadata as second argument.\n\nA module, function, arguments triplet can also be used. For example, if\n`{Foo, :bar, [1, 2]}` is used as message handler, the consumer will call\n`Foo.bar(message, meta, 1, 2)` to handle messages.\n\nThis function must return `:ok` if the messages was handled successfully, so\nthe consumer will acknowledge the message. Any other return value will\nnon-acknowledge the message.","ref":"AMQPHelpers.Reliability.Consumer.html#t:message_handler/0"},{"type":"type","title":"AMQPHelpers.Reliability.Consumer.option/0","doc":"Option values used by `start_link/1` function.","ref":"AMQPHelpers.Reliability.Consumer.html#t:option/0"},{"type":"type","title":"AMQPHelpers.Reliability.Consumer.options/0","doc":"Options used by `start_link/1` function.","ref":"AMQPHelpers.Reliability.Consumer.html#t:options/0"},{"type":"module","title":"AMQPHelpers.Reliability.Producer","doc":"A producer for dealing with reliability scenarios.\n\nA `AMQPHelpers.Reliability.Producer` is process which manages a reliable\nsend operation over *AMQP*, where messages are acknowledge by the broker\nafter sending them. [Publisher Confirms](https://www.rabbitmq.com/confirms.html#publisher-confirms)\nAMQP extension is used to achieve this.","ref":"AMQPHelpers.Reliability.Producer.html"},{"type":"module","title":"Example - AMQPHelpers.Reliability.Producer","doc":"This `Producer` enforces the usage of `AMQP.Application`, so after defining\nour application connection and channel we can start a producer and start\npublishing message in a reliable way.\n\n    alias AMQPHelpers.Reliability.Producer\n\n    {:ok, producer} = Producer.start_link(channel_name: :my_channel_name)\n\n    Producer.publish(producer, \"exchange\", \"routing_key\", \"payload\", message_id: \"foo\")","ref":"AMQPHelpers.Reliability.Producer.html#module-example"},{"type":"function","title":"AMQPHelpers.Reliability.Producer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"AMQPHelpers.Reliability.Producer.html#child_spec/1"},{"type":"function","title":"AMQPHelpers.Reliability.Producer.publish/6","doc":"Publish a message ensuring that the broker receives it.\n\nSimilar to `c:AMQPHelpers.Adapter.publish/5` but ensures that the broker\nreceives the message sent. Some message delivery options are enabled by\ndefault (`mandatory` and `persistent`) and `message_id` option **is required**\nto track the message state.","ref":"AMQPHelpers.Reliability.Producer.html#publish/6"},{"type":"function","title":"AMQPHelpers.Reliability.Producer.setup_channel/1","doc":"Setups the channel for reliable message delivery.\n\nThis function is used to setup reliable message delivery when\n`setup_channel_on_init` is set to false. Not required by default but useful\nfor testing purposes.","ref":"AMQPHelpers.Reliability.Producer.html#setup_channel/1"},{"type":"function","title":"AMQPHelpers.Reliability.Producer.start_link/1","doc":"Starts a `Producer` process linked to the current process.","ref":"AMQPHelpers.Reliability.Producer.html#start_link/1"},{"type":"function","title":"Options - AMQPHelpers.Reliability.Producer.start_link/1","doc":"The following option can be given to `Producer` when starting it. Note that\n`queue_name` **is required**.\n\n  * `adapter` - Sets the `AMQPHelpers.Adapter`. Defaults to\n    `AMQPHelpers.Adapters.AMQP`.\n  * `setup_channel_on_init` - Whether to configure the channel for reliable\n    message sending on init or not. Defaults to `false`.\n  * `channel` - The channel to use to consume messages. **NOTE**: do **not**\n    use this for production environments because this *producer* does not\n    supervise the given channel. Instead, use `channel_name` which makes use \n    of `AMQP.Application`.\n  * `channel_name` - The name of the configured channel to use. See\n    `AMQP.Application` for more information. Defaults to `:default`.\n  * `retry_interval` - The number of millisecond to wait if an error happens\n    when trying to consume messages or when trying to open a channel.\n\n`t:GenServer.options/0` are also available. See `GenServer.start_link/2` for\nmore information about these.","ref":"AMQPHelpers.Reliability.Producer.html#start_link/1-options"},{"type":"type","title":"AMQPHelpers.Reliability.Producer.option/0","doc":"Option values used by `start_link/1` function.","ref":"AMQPHelpers.Reliability.Producer.html#t:option/0"},{"type":"type","title":"AMQPHelpers.Reliability.Producer.options/0","doc":"Options used by `start_link/1` function.","ref":"AMQPHelpers.Reliability.Producer.html#t:options/0"},{"type":"extras","title":"AMQP Helpers","doc":"# AMQP Helpers\n\n[![Build and Test](https://github.com/kantox/amqp_helpers/actions/workflows/build-test.yml/badge.svg)](https://github.com/kantox/amqp_helpers/actions/workflows/build-test.yml)\n[![Coverage Status](https://coveralls.io/repos/github/kantox/amqp_helpers/badge.svg?branch=main&t=VbtrhR)](https://coveralls.io/github/kantox/amqp_helpers?branch=main)\n\nNon opinionated [AMQP](https://github.com/pma/amqp) helpers for common\nscenarios.","ref":"readme.html"},{"type":"extras","title":"Installation - AMQP Helpers","doc":"To use _AMQPHelpers_ you need [AMQP](https://github.com/pma/amqp). You can\ninstall both by adding `amqp` and `amqp_helpers` to your list of dependencies in\n`mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:amqp, \"~> 3.0\"},\n    {:amqp_helpers, \"~> 1.1\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Motivation - AMQP Helpers","doc":"This library provides several wrappers and utilities around some common use\ncases of _AMQP_. It provides a simple interface, following common _OTP_ patterns\nand [Elixir library guidelines](https://hexdocs.pm/elixir/master/library-guidelines.html)\nto avoid any opinionated interface. Other generalist abstractions can be built\non top of _AMQPHelpers_ to provide ergonomics or any other feature not strictly\ntied to _AMQP_.\n\nRight now, the utilities built in this library are suited for uses that try to\noptimize _AMQP_ for high throughput and for scenarios that require data safety\nat any cost.","ref":"readme.html#motivation"},{"type":"extras","title":"Comparisons With Other Libraries - AMQP Helpers","doc":"This is how this library relates to other available libraries in order to\nhighlight the motivation behind this library:\n\n- [**AMQP**](https://hexdocs.pm/amqp/readme.html): this library is not a\n  replacement in any way to this library, but a companion.\n- [**AMQPx**](https://hexdocs.pm/amqpx): in some way, similar to this library,\n  but not tied to any particular use case and some of its functionality has been\n  superseded by `AMQP` v2.x.\n- [**Broadway**](https://hexdocs.pm/broadway/Broadway.html): this is an\n  abstraction for message processing, which cannot be compared directly to this\n  library. [`broadway_rabbitmq`](https://github.com/dashbitco/broadway_rabbitmq)\n  is a connector for `AMQP` and can be adapted to use this library if needed.\n  Nevertheless, unless you want to support multiple transports, most of the\n  features provided by `Broadway` can be implemented directly by using some\n  _RabbitMQ_/_AMQP_ features (there are exceptions like graceful shutdown).\n- [**GenAmqp**](https://hexdocs.pm/gen_amqp): provides some utilities in the\n  same way that this library, but not tied to any specific use case. Also, some\n  of its functionality has been superseded by `AMQP` v2.x.\n- [**PlugAmqp**](https://hexdocs.pm/rambla/getting-started.html): It will use\n  this library, but have different purposes (it implements _RPC_ pattern over\n  _AMQP_).\n- [**Rambla**](https://hexdocs.pm/rambla/getting-started.html): similar to\n  `Broadway`, but from the publishing point of view.\n\nIn summary, this library provides helpers tied to specific use cases of _AMQP_,\nwithout any kind of abstraction over it. If you are looking to support\ndifferent kinds of transports in your library, check out libraries like\n`Broadway` or `Rambla`.","ref":"readme.html#comparisons-with-other-libraries"},{"type":"extras","title":"AMQP Good Practices - AMQP Helpers","doc":"This library enforces some good practices that have no downside for any\napplication using _AMQP_ and ease the development of _AMQP_ related features.\n\nThe first one is the use of an _AMQP_ implementation behind a behaviour, called\n`AMQPHelpers.Adapter`. This allow us to provide stub, mocks or even different\ntransport layers that mimic the _AMQP_ interface.\n\nThe second one is the use of [application connection/channels](`AMQP.Application`).\nThis an _AMQP_ v2.x feature which replaces (or aid) previous connections\nsupervisors or channel pools. As general thumb rule, your application should\nhave at most two connection (in/out) and one channel per multiplexing process.","ref":"readme.html#amqp-good-practices"},{"type":"extras","title":"User Case Scenarios - AMQP Helpers","doc":"These are the _AMQP_ use cases are covered in _AMQP Helpers_ right now:\n\n- A performance-intensive scenario in which a high throughput message delivery\n  rate is desired. Trade-offs in reliability are acceptable.\n\n- A reliable scenario in which data safety is a must, even if performance is\n  compromised.\n\n- Remote procedure calls using [Direct Reply-to](https://www.rabbitmq.com/direct-reply-to.html).\n\nThere are some other features, like _High Availability_, _Observability_,\n_Exclusivity_, etc. that can be achieved in both scenarios but are not\nexplicitly covered here.","ref":"readme.html#user-case-scenarios"},{"type":"extras","title":"High Throughput - AMQP Helpers","doc":"To achieve the best performance in terms of message delivery some trade-off must\nbe done, which usually impacts the reliability and/or coherence of the system.\n\nDurability should be disabled. In other words, messages will not be persisted,\nso messages could be lost in a broker outage scenario. This can be configured by\ndeclaring queues as non-durable and publishing messages with `persistent` set to\n`false`.\n\nAcknowledges, from any communication direction, should be disabled. This means\nthat the publisher should not confirm deliveries, and consumers should not\nacknowledge messages. Messages could be lost on the flight because of network or\nedge issues. Publisher confirms are not enabled by default, so nothing has to be\ndone in terms of publishing. Consuming requires disabling acknowledging, which\ncan be done by setting the `no_ack` flag on.\n\nThe `AMQPHelpers.HighThroughput` module provides functions that enforce these\nrequirements for publishing and consuming. These are simple wrappers around\n_AMQP_ library functions. They add very little aside from being explicit about\na feature of some scenario (performance intensive).\n\nSome other considerations should have taken into account when declaring queues\nfor this purpose, which are:\n\n- `x-max-length` or `x-max-length-bytes` with `x-expires` and `x-messages-ttl`\n  should be used to avoid large queues. Large queues slowdown message delivery.\n  This option limits the size of the queue to a known threshold.\n\n- `x-queue-mode` should **not** be `\"lazy\"` to avoid moving messages to disk.\n\n- Queues should not be replicated, nor enabling [high availability](https://www.rabbitmq.com/ha.html)\n  nor using [quorum queues](https://www.rabbitmq.com/quorum-queues.html). Both\n  method have implications in the performance of the queue.\n\n- `durable` should be set to `false`.","ref":"readme.html#high-throughput"},{"type":"extras","title":"Reliability - AMQP Helpers","doc":"For reliability, [Acknowledgements and Confirms](https://www.rabbitmq.com/confirms.html)\nare used, which have an impact in performance. Reliability is not only achieved\nat client level, broker configuration and monitoring are also important topics\nhere. You can read [RabbitMQ's Reliability Guide](https://www.rabbitmq.com/reliability.html)\nfor more information.\n\nThe `AMQPHelpers.Reliability.Consumer` and `AMQPHelpers.Reliability.Producer`\nprovide processes to consume and publish messages in a reliable fashion. The\n`Consumer` uses standard AMQP acknowledges mechanism to notify that messages are\nconsumed successfully. The `Producer` uses the _Publisher Confirms_ extension to\nget notified about successfully message deliveries.\n\nA system which uses the provided `Reliability.Consumer` and\n`Reliability.Producer` will guarantee that no message is lost, and at least one\nmessage is delivered. For high availability you can pair this processes with\nmirrored queues. For consistency, you can use\n[deduplication plugin](https://github.com/noxdafox/rabbitmq-message-deduplication)\nor [quorum queues](https://www.rabbitmq.com/quorum-queues.html) (Which also\nguarantees message order).","ref":"readme.html#reliability"},{"type":"extras","title":"Testing - AMQP Helpers","doc":"This library provides an _AMQP_ interface at `AMQPHelpers.Adapter` which can\nbe used with libraries like [Mox](https://github.com/dashbitco/mox) to mock any\npart of the _AMQP_ interface. Check out the tests of this library to see some\nexamples.\n\nTwo adapter implementations are provided with this library:\n\n- `AMQPHelpers.Adapters.Stub` - A stub implementation that only logs calls.\n- `AMQPHelpers.Adapters.AMQP` - An implementation that uses `AMQP` library.\n\nAll the functionally exposed by the library support in one or another way a\nconfigurable adapter (defaults to `AMQP` implementation).","ref":"readme.html#testing"},{"type":"extras","title":"References - AMQP Helpers","doc":"- [CloudAMQP - RabbitMQ Best Practices for High Availability](https://www.cloudamqp.com/blog/part3-rabbitmq-best-practice-for-high-availability.html)\n- [CloudAMQP - RabbitMQ Best Practices for High Performance](https://www.cloudamqp.com/blog/part2-rabbitmq-best-practice-for-high-performance.html)\n- [CloudAMQP - RabbitMQ Best Practices](https://www.cloudamqp.com/blog/part1-rabbitmq-best-practice.html)\n- [RabbitMQ Docs - Reliability Guide](https://www.rabbitmq.com/reliability.html)\n- [RabbitMQ in Depth](https://www.manning.com/books/rabbitmq-in-depth)","ref":"readme.html#references"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,49]}}